'iMac G4 17" Hackintosh Sleep LED "breathing" 
'------ Written by MacTester57 and modified to suit by Ersterhernd -------
'USB 5v connected to pin 5v picaxe supply pin 
'Front Panel Header pin 9 connected to pin c.3
'LED will stay dimly lit during normal use, pulse during sleep and go off when iMac is powered down
'this is slightly different from the original LED configuration, because the LED stays dimly lit when iMac is turned on


setfreq m4						'set chip frequency to 4MHz

#Picaxe 08M2						'set Picaxe chip type to 08M2

symbol defaultbrightness = w0
symbol brightness = w1			'variables and constants assignment in this section
symbol ramped_down = b4
symbol LED = c.2

init: 
	let defaultbrightness = 90			'Set default brightness so unobtrusively dim
	pwmout LED,99,0					'set pwm duty to 10khz at 0% Duty Cycle
	pwmduty LED, defaultbrightness
	let ramped_down = 1

main:
	
	if  pinc.3 = 0 then             'Only USB Power - Sleep Mode is ON - Pulse the LED
		goto pulsate
	endif
	
	pwmduty LED, defaultbrightness

	goto main			
											
	
pulsate:

	if ramped_down = 1 then
		for brightness=0 to 40 step 1 	'ramp brightness very slow up (from 0)--
			pwmduty LED,brightness
			pause 50
		next brightness
		goto slowup
	else
		for brightness=20 to 40 step 2 	'ramp brightness very slow up (from 20)--
			pwmduty LED,brightness
			pause 50
		next brightness
	endif		

slowup:	let ramped_down = 0
		for brightness=40 to 60 step 2 	'ramp brightness slow up
			pwmduty LED,brightness
			pause 20
		next brightness

		for brightness=60 to 80 step 2 	'ramp brightness up
			pwmduty LED,brightness
			pause 2
		next brightness

		for brightness=80 to 400 step 3 	'ramp brightness fast up
			pwmduty LED,brightness
		next brightness

		for brightness=400 to 80 step -3 	'ramp brightness fast down
			pwmduty LED,brightness
		next brightness

		for brightness=80 to 60 step -2 	'ramp brightness down
			pwmduty LED,brightness
			pause 2
		next brightness

		for brightness=60 to 40 step -2 	'ramp brightness slow down
			pwmduty LED,brightness
			pause 20
		next brightness

		for brightness=40 to 20 step -2 	'ramp brightness very slow down
			pwmduty LED,brightness
			pause 50
		next brightness

		pause 500 'wait 0.5s
		goto main
